// FLOPPY

void Floppy::step(bool dir) {
	if (dir) {if (trk < (trk80?86:43)) trk++;}
	else {if (trk>0) trk--;}
}

void Floppy::tick() {
	index=false;
	uchar dta;
	bool fast = ((vg93.cop & 0xf8)!=0x50);	// read/write operations not fully turbed
	rtrk = trk*2; if (dblsid) rtrk+=(side?0:1);
	if (insert) {
		if (pos==0 && spin==0) iback=140;
		if (iback>0) iback--;
		index = (iback>0);
		spin++;
		if (spin > (bdi.turbo?(fast?5:150):224)) {
			field=fnext;
			spin=0;
			pos++;
			if (pos>=TRACKLEN) {pos=0;field=0;fnext=0;}
			dta=data[rtrk][pos];
			if (field==0) {
				if (dta==0xfe) {fnext=1;datalen=6;}
				if (dta==0xfb) {fnext=2;datalen=(128<<(bufer[3]));}
				if (dta==0xf8) {fnext=3;datalen=(128<<(bufer[3]));}
			} else {
				if (field==1) bufer[6-datalen]=dta;
				datalen--;
				if (datalen==0) fnext=0;
			}
		}
	}
	if (scount>0) scount--;
}

void Floppy::format() {uchar i; for (i=0;i<168;i++) formtrack(i,NULL);}

void Floppy::formtrack(uchar tr,uchar *bpos) {
	if (bpos==NULL) bpos = new uchar[0x1000];
	uchar* tpos = &data[tr][0];
	uchar* tbpos = tpos;
	uchar rtr = ((tr&0xfe)/2);
	uchar sd = (tr&0x01)?1:0;
	int i,sc;
	for (i=0;i<12;i++) *(tpos++)=0x00;		// sync
	*(tpos++)=0xc2; *(tpos++)=0xc2; *(tpos++)=0xc2; *(tpos++)=0xfc;
	for (sc=1;sc<17;sc++) {
		for(i=0;i<10;i++) *(tpos++)=0x4e;
		for(i=0;i<12;i++) *(tpos++)=0x00;
		*(tpos++)=0xa1; *(tpos++)=0xa1; *(tpos++)=0xa1; *(tpos++)=0xfe;
		*(tpos++)=rtr; *(tpos++)=sd; *(tpos++)=sc; *(tpos++)=0x01;
		*(tpos++)=0xf7; *(tpos++)=0xf7;
		for(i=0;i<22;i++) *(tpos++)=0x4e;
		for(i=0;i<12;i++) *(tpos++)=0x00;
		*(tpos++)=0xa1; *(tpos++)=0xa1; *(tpos++)=0xa1; *(tpos++)=0xfb;
		for (i=0;i<256;i++) {
			*tpos = *bpos;
			tpos++; bpos++;
		}
		*(tpos++)=0xf7; *(tpos++)=0xf7;
		for(i=0;i<60;i++) *(tpos++)=0x4e;
	}
	while ((tpos - tbpos) < TRACKLEN) {*(tpos++)=0x4e;}
}

bool Floppy::eject() {
	if (!savecha()) return false;
	path = "";
	insert = false;
	changed = false;
	return true;
}

bool Floppy::savecha() {
	bool res=true;
	if (changed) {
		QMessageBox mbox;
		mbox.setText(QString("<b>Disk ").append(QChar(0x41+id)).append(": has been changed</b>"));
		mbox.setInformativeText("Do you want to save it?");
		mbox.setStandardButtons(QMessageBox::Yes|QMessageBox::Ignore|QMessageBox::Cancel);
		mbox.setIcon(QMessageBox::Warning);
		int ret=mbox.exec();
		if (ret==QMessageBox::Yes) {res=savedisk(path,id);}			// save
		if (ret==QMessageBox::Ignore) res=true;					// don't save
		if (ret==QMessageBox::Cancel) res=false;				// cancel
	}
	return res;
}

void Floppy::load(std::string sfnam, uchar type) {
	if (!savecha()) return;
	std::ifstream file(sfnam.c_str(),std::ios::binary);
	QMessageBox mbx; mbx.setIcon(QMessageBox::Critical);
	if (!file.good()) {
		mbx.setText("Can't open file");
		mbx.setInformativeText(sfnam.c_str());
		mbx.exec();
		return;
	}
	uchar* buf = new uchar[0x1000];
	uchar i,fcnt,tcnt,scnt;
	uchar* bptr = buf;
	bool err;
	long len;
	switch(type) {
		case TYPE_TRD:
			file.seekg(0x8e7);
			tmp = file.peek();
			file.seekg(0,std::ios::end);
			len = file.tellg();
			file.seekg(0,std::ios::beg);
			err = ((len&0xfff)!=0) || (len==0) || (len>0xa8000);
			if (err || tmp!=0x10) {
				mbx.setText("<b>Wrong TRD file</b>");
				if (err) {mbx.setInformativeText("Incorrect lenght");}
					else {mbx.setInformativeText("Not TRDos image");}
				mbx.exec();
			} else {
				format();
				i=0;
				do {
					file.read((char*)buf,0x1000);
					formtrack(i,buf);
					i++;
				} while (!file.eof());
				insert = true;
				path = sfnam;
				changed = false;
			}
			break;
		case TYPE_SCL:
			file.read((char*)buf,9);
			mbx.setText("<b>Wrong SCL file</b>");
			if (std::string((const char*)buf,8) != "SINCLAIR") {mbx.setInformativeText("Wrong signature"); mbx.exec(); break;}
			if (buf[8]>0x80) {mbx.setInformativeText("More than 128 files inside"); mbx.exec(); break;}
			format();
			fcnt = buf[8];
			tcnt = 1; scnt = 0;
			for (i=0;i<fcnt;i++) {
				file.read((char*)bptr,14); bptr += 14;
				*(bptr++) = scnt; *(bptr++) = tcnt;
				scnt += (*(bptr-3) & 0x0f);
				tcnt += ((*(bptr-3) & 0xf0)>>4)+((scnt & 0xf0)>>4);
				scnt &= 0x0f;
			}
			*(bptr)=0;
			buf[0x800]=0; buf[0x8e1]=scnt; buf[0x8e2]=tcnt;
			buf[0x8e3]=0x16; buf[0x8e4]=fcnt;
			tadr = ((160-tcnt)<<4)-scnt;
			buf[0x8e5]=(tadr&0xff); buf[0x8e6]=(tadr>>8);
			buf[0x8e7]=0x10;
			formtrack(0,buf);
			i=1;
			while (!file.eof()) {
				file.read((char*)buf,0x1000);
				formtrack(i,buf);
				i++;
			}
			insert = true;
			path = sfnam;
			changed=false;
			break;
	}
}

bool Floppy::getsector(uchar tr,uchar sc,uchar* buf) {
	uchar* dptr = &data[tr][0];
	bool fnd;
	while (1) {
		while (*dptr != 0xfe) {dptr++; if (dptr > &data[tr][0]+TRACKLEN) return false;}
		fnd = (*(dptr+3)==sc);
		dptr+=6;
		while (*dptr!=0xf8 && *dptr!=0xfb) {dptr++; if (dptr > &data[tr][0]+TRACKLEN) return false;}
		if (fnd) {memcpy(buf,dptr+1,256); return true;}
		dptr+=0x103;
	}
}

struct FilePos {
	uchar trk;
	uchar sec;
	uchar slen;
};

void Floppy::save(std::string fnam, uchar type) {
	if (!insert) return;
	QMessageBox mbx;
	mbx.setIcon(QMessageBox::Critical);
	const char* sign = "SINCLAIR";
	uchar* img = new uchar[0xa0000];
	FilePos newfp;
	std::vector<FilePos> fplist;
	uchar* buf = new uchar[256];
	uchar *bptr;
	uchar* dptr = img;
	uchar i,j,tr,sc;
	std::ofstream file; 
	switch (type) {
		case TYPE_TRD:
			for (i=0; i<160; i++) {
				for (j=1; j<17; j++) {
					if (!getsector(i,j,dptr)) {
						mbx.setText("<b>Error parsing disk</b>");
						mbx.setInformativeText("Sector not found");
						mbx.setDetailedText(QString("track\t").append(QString::number(i)).append("\nsector\t").append(QString::number(j)));
						mbx.exec();
						i=j=200;
						break;
					}
					dptr+=256;
				}
			}
			if (i<200) {file.open(fnam.c_str(),std::ios::binary); file.write((const char*)img,0xa0000);}
			break;
		case TYPE_SCL:
			memcpy(img,sign,8);
			img[8]=0;
			dptr = img+9;
			for (i=1; i<9; i++) {
				getsector(0,i,buf);
				bptr = buf;
				for (j=0; j<16; j++) {
					if (*bptr == 0) {i=j=20;}
					else {
						if (*bptr != 1) {
							memcpy(dptr,bptr,14);
							newfp.trk = *(bptr+15);
							newfp.sec = *(bptr+14);
							newfp.slen = *(bptr+13);
							fplist.push_back(newfp);
							dptr+=14; img[8]++;
						}
						bptr+=16;
					}
				}
			}
			for (i=0;i<fplist.size();i++) {
				tr = fplist[i].trk;
				sc = fplist[i].sec;
				for(j=0;j<fplist[i].slen;j++) {
					getsector(tr,sc+1,dptr);
					dptr+=256;
					sc++; if (sc>15) {tr++; sc=0;}
				}
			}
			file.open(fnam.c_str(),std::ios::binary); file.write((const char*)img,dptr-img);
			break;
	}
}
