void savesettings() {
	std::ofstream sfile(optpath.c_str());
	uint i,j;

	sfile<<"[VIDEO]\n\n";
	sfile<<"doublesize = "<<(doublesize?"y":"n")<<"\n";
	sfile<<"fullscreen = "<<(fullscrn?"y":"n")<<"\n";
	sfile<<"bordersize = "<<int2str(bordersize).c_str()<<"\n";

	sfile<<"\n[SCREENSHOTS]\n\n";
	sfile<<"folder = "<<screenshotdir.c_str()<<"\n";
	sfile<<"format = "<<screenshotformat.c_str()<<"\n";
	sfile<<"combo.count = "<<int2str(sshotrptcount).c_str()<<"\n";
	sfile<<"combo.interval = "<<int2str(sshotrpttime).c_str()<<"\n";

	sfile<<"\n[SOUND]\n\n";
	sfile<<"enabled = "<<(soundenabled?"y":"n")<<"\n";
	sfile<<"# possible sound systems are:";
	for (i=0;i<soundsyslist.size();i++) {
		if (i!=0) sfile<<", ";
		sfile<<soundsyslist[i].name.c_str();
	}
	sfile<<"\n";
	sfile<<"soundsys = "<<cursoundsys->name.c_str()<<"\n";
	sfile<<"dontmute = "<<(inactivesnd?"y":"n")<<"\n";
	sfile<<"rate = "<<int2str(sndfreqs[cursndfreq]).c_str()<<"\n";
	sfile<<"buffer.len = "<<int2str(sndbuflen).c_str()<<"\n";
	sfile<<"volume.beep = "<<int2str(beepvolume).c_str()<<"\n";
	sfile<<"volume.tape = "<<int2str(tapevolume).c_str()<<"\n";
	sfile<<"volume.ay = "<<int2str(ayvolume).c_str()<<"\n";
	sfile<<"ay.freq = "<<int2str(ayfreq).c_str()<<"\n";

	sfile<<"\n[BETADISK]\n\n";
	sfile<<"enabled = "<<(bdi.enable?"y":"n")<<"\n";
	sfile<<"fast = "<<(bdi.turbo?"y":"n")<<"\n";

	sfile<<"\n[MACHINE]\n\n";
	sfile<<"# possible machines are:";
	for (i=0;i<machlist.size();i++) {
		if (i!=0) sfile<<", ";
		sfile<<machlist[i].name.c_str();
	}
	sfile<<"\n";
	sfile<<"current = "<<machlist[curmachine].name.c_str()<<"\n";
	sfile<<"restart = "<<(resetafterchange?"y":"n")<<"\n";

	sfile<<"\n[ROMSETS]\n\n";
	std::vector<std::string> rmnam;
	rmnam.push_back("basic128"); rmnam.push_back("basic48"); rmnam.push_back("shadow"); rmnam.push_back("trdos");
	rmnam.push_back("ext4"); rmnam.push_back("ext5"); rmnam.push_back("ext6"); rmnam.push_back("ext7");
	for (i=0;i<romslist.size();i++) {
		sfile<<"name = "<<romslist[i].name.c_str()<<"\n";
		for (j=0;j<8;j++) {
			if (romslist[i].path[j]!="") {
				sfile<<rmnam[j].c_str()<<" = "<<romslist[i].path[j].c_str();
				if (romslist[i].part[j]!=0) sfile<<":"<<int2str(romslist[i].part[j]).c_str();
				sfile<<"\n";
			}
		}
		sfile<<"\n";
	}
	sfile<<"zx48romset = "<<machlist[0].romset->name.c_str()<<"\n";
	sfile<<"zx128romset = "<<machlist[1].romset->name.c_str()<<"\n";
	sfile<<"scorpionromset = "<<machlist[2].romset->name.c_str()<<"\n";
	sfile<<"plus3romset = "<<machlist[3].romset->name.c_str()<<"\n";

	sfile<<"\n[TOOLS]\n\n";
	sfile<<"sjasm = "<<sjapath.c_str()<<"\n";
	
	sfile<<"\n[MENU]\n\n";
	for (i=0; i<usermenu.size(); i++) {
		sfile<<usermenu[i].name.c_str()<<" = "<<usermenu[i].path.c_str()<<"\n";
	}
}
/*
uchar getromsetindex(std::string rsnam) {
	uchar res = 0;
	for (tmp=0; tmp<romslist.size(); tmp++) {
		if (romslist[tmp].name == rsname) {res=tmp;}
	}
	return res;
}
*/
bool str2bool(std::string value) {
	return ((value=="y") || (value=="Y") || (value=="1") || (value=="yes") || (value=="YES"));
}

void setromset(uchar num, std::string rsname) {
	machlist[num].romset = &emptyrs;
	uchar i;
	for (i=0; i<romslist.size(); i++) {
		if (romslist[i].name == rsname) machlist[num].romset = &romslist[i];
	}
}

void setromparam(std::string pnam,std::string pval) {
	size_t pos = pval.find_last_of(":");
	std::string fnam;
	uchar fprt;
	if (pos != std::string::npos) {
		fnam = std::string(pval,0,pos);
		std::string tms = std::string(pval,pos+1);
		if (tms=="") {fprt = 0;} else {fprt = atoi(tms.c_str());}
	} else {
		fnam = pval; fprt = 0;
	}
	if (pnam=="name") {
		RomSet newrs;
		newrs.name = pval;
		newrs.path = std::vector<std::string> (8,"");
		romslist.push_back(newrs);
	}
	if (pnam=="basic128") {romslist.back().path[0]=fnam; romslist.back().part[0]=fprt;}
	if (pnam=="basic48") {romslist.back().path[1]=fnam; romslist.back().part[1]=fprt;}
	if (pnam=="shadow") {romslist.back().path[2]=fnam; romslist.back().part[2]=fprt;}
	if (pnam=="trdos") {romslist.back().path[3]=fnam; romslist.back().part[3]=fprt;}
	if (pnam=="zx48romset") setromset(0,pval);
	if (pnam=="zx128romset") setromset(1,pval);
	if (pnam=="scorpionromset") setromset(2,pval);
	if (pnam=="plus3romset") setromset(3,pval);
}

void setbordersize(float prc) {
	if ((prc<0) or (prc>1)) return;
	hlcut = int(hbrdlen - prc*(hbrdlen - hsynclen));
	hrcut = hticks - hlcut + hsynclen;
	vucut = int(vbrdlen - prc*(vbrdlen - vsynclen));
	vdcut = vlines - vucut + vsynclen;
	xscrsize = hrcut - hlcut;
	yscrsize = vdcut - vucut;
	dlinepos = 3*xscrsize*(yscrsize-1);
	twolines = 6*xscrsize;
	intupt = true;
}

void setvidparam(std::string pnam, std::string pval) {
	if (pnam=="doublesize") doublesize=str2bool(pval);
	if (pnam=="fullscreen") fullscrn=str2bool(pval);
	if (pnam=="bordersize") {
		int test = atoi(pval.c_str());
		if ((test>-1) && (test<101)) {
			bordersize=test;
			setbordersize(bordersize/100.0);
		}
	}
}

void setsshparam(std::string pnam, std::string pval) {
	if (pnam=="folder") screenshotdir=pval;
	if (pnam=="format") screenshotformat=pval;
	if (pnam=="combo.count") sshotrptcount=atoi(pval.c_str());
	if (pnam=="combo.interval") sshotrptcount=atoi(pval.c_str());
}

void setsndparam(std::string pnam, std::string pval) {
	if (pnam=="enabled") soundenabled=str2bool(pval);
	if (pnam=="dontmute") inactivesnd=str2bool(pval);
	if (pnam=="soundsys") {
		uint i;
		for(i=0;i<soundsyslist.size();i++) {if (pval == soundsyslist[i].name) cursndsys=i;}
	}
	if (pnam=="rate") {
		if (pval=="44100") cursndfreq=0;
		if (pval=="22050") cursndfreq=1;
		if (pval=="11025") cursndfreq=2;
	}
	if (pnam=="buffer.len") sndbuflen=atof(pval.c_str());
	if (pnam=="volume.beep") beepvolume=atoi(pval.c_str());
	if (pnam=="volume.tape") tapevolume=atoi(pval.c_str());
	if (pnam=="volume.ay") ayvolume=atoi(pval.c_str());
	if (pnam=="ay.freq") ayfreq=atoi(pval.c_str());
}

void setdskparam(std::string pnam, std::string pval) {
	if (pnam=="enabled") bdi.enable=str2bool(pval);
	if (pnam=="fast") bdi.turbo=str2bool(pval);
}

void setoolparam(std::string pnam, std::string pval) {
	if (pnam=="sjasm") sjapath=pval;
}

void setmacparam(std::string pnam, std::string pval) {
	if (pnam=="current") {
		uint i;
		for (i=0;i<machlist.size();i++) {
			if (pval == machlist[i].name) curmachine=i;
		}
	}
	if (pnam=="restart") resetafterchange=str2bool(pval);
}

void setmenuparam(std::string pnam, std::string pval) {
	MenuEntry newme;
	newme.name = pnam;
	newme.path = pval;
	usermenu.push_back(newme);
}

bool changesection(std::string line) {
	uchar md = tmp2;
	if (line.find("[ROMSETS]")==0) tmp2=1;
	if (line.find("[VIDEO]")==0) tmp2=2;
	if (line.find("[SCREENSHOTS]")==0) tmp2=3;
	if (line.find("[SOUND]")==0) tmp2=4;
	if (line.find("[BETADISK]")==0) tmp2=5;
	if (line.find("[MACHINE]")==0) tmp2=6;
	if (line.find("[TOOLS]")==0) tmp2=7;
	if (line.find("[MENU]")==0) tmp2=8;
	return (md != tmp2);
}

void loadsettings() {
	std::ifstream file(optpath.c_str());
	std::string line,pnam,pval;
	size_t pos;
	char* buf = new char[1024];
	if (file.good()) {
		tmp2=0;
		while (!file.eof()) {
			file.getline(buf,1024);
			line = std::string(buf);
			do {pos = line.find("\r"); if (pos!=std::string::npos) line.erase(pos);} while (pos!=std::string::npos);
			do {pos = line.find("\n"); if (pos!=std::string::npos) line.erase(pos);} while (pos!=std::string::npos);
			if (!changesection(line)) {
				pnam = pval = "";
				pos = line.find("=");
				if (pos!=std::string::npos) {
					pnam = std::string(line,0,pos);
					pval = std::string(line,pos+1);
					pos = pnam.find_last_not_of(" ");
					if (pos!=std::string::npos) pnam = std::string(pnam,0,pos+1);		// delete last spaces
					pos = pnam.find_first_not_of(" ");
					if (pos!=std::string::npos) pval = std::string(pval,pos+1);	// delete first spaces
				}
				if (pval!="") {
					switch (tmp2) {
						case 1: setromparam(pnam,pval); break;
						case 2: setvidparam(pnam,pval); break;
						case 3: setsshparam(pnam,pval); break;
						case 4: setsndparam(pnam,pval); break;
						case 5: setdskparam(pnam,pval); break;
						case 6: setmacparam(pnam,pval); break;
						case 7: setoolparam(pnam,pval); break;
						case 8: setmenuparam(pnam,pval); break;
					}
				}
			}
		}
	}
}
