// DAAAAAAAAAAAAAA

void daa() {
	unsigned char flagz=(reg[6]&3)*2+(testflag(4)?1:0);	// NCH
//qDebug()<<"NCH="<<flagz<<"before:"<<hexbyte(reg[7]);
	switch (flagz) {
		case 0:
			if ((reg[7]&0x0f)<10) {
				if (reg[7]>0x9f) {reg[7]=reg[7]+0x60; affectflag(0,true);}
			} else {
				if (reg[7]<0x90) {reg[7]=reg[7]+0x06; affectflag(0,false);} else {reg[7]=reg[7]+0x66; affectflag(0,true);}
			}
			break;
		case 1:
			if (reg[7]<0xa0) {reg[7]=reg[7]+6; affectflag(0,false);} else {reg[7]=reg[7]+0x66; affectflag(0,true);}
			break;
		case 2: reg[7]=reg[7]+0x60+(((reg[7]&0x0f)>9)?6:0); affectflag(0,true); break;
		case 3: reg[7]=reg[7]+0x66; affectflag(0,true); break;
		case 4: break;
		case 5: reg[7]=reg[7]-0x06; affectflag(0,false); break;
		case 6: reg[7]=reg[7]-0x60; affectflag(0,true); break;
		case 7: reg[7]=reg[7]-0x66; affectflag(0,true); break;
	}
//qDebug()<<"after:"<<hexbyte(reg[7]);
}

// in-out

void out(int port,unsigned char value,unsigned char tcks=4) {
//	int fullport = port;
	port=machine->getport(port);
	if (bdi.pcatch) {bdi.out(port,value);} else {machine->out(port,value);}
	ticks(tcks);
}

unsigned char in(int port,unsigned char tcks=4) {
	unsigned char res=0xff;
	port=machine->getport(port);
	if (bdi.pcatch) {res=bdi.in(port);} else {res=machine->in(port);}
	ticks(tcks);
	return res;
}

void outreg(unsigned char idx) {
	out(getpair(0),reg[idx]);
}

void inreg(unsigned char idx) {
	unsigned char opt;
	opt=in(getpair(0));
	if (idx!=6) {reg[idx]=opt;}
	affectflag(7,opt&0x80);
	affectflag(6,opt==0);
	affectflag(4,false);
	affectflag(2,parity(opt));
	affectflag(1,false);
}

// ld

void ldreg(unsigned char dst, unsigned char src, bool isnumber=false) {
	if (isnumber) {
		if (dst==6) {tadr=getindex(); src=getbyte(); writemem(tadr,src);} else {reg[corridx(dst)]=getbyte();}
	} else {
		if (src==6) {reg[dst]=readmem(getindex());} else {
			if (dst==6) {writemem(getindex(),reg[src]);} else {reg[corridx(dst)]=reg[corridx(src)];}
		}
	}
}

void ldmnnrp(unsigned char idx) {
	tadr=getword();
	writemem(tadr,reg[idx+1]);
	writemem(tadr+1,reg[idx]);
}

void ldrpmnn(unsigned char idx) {
	tadr=getword();
	reg[idx+1]=readmem(tadr);
	reg[idx]=readmem(tadr+1);
}

void ldair(unsigned char value) {
	ticks(1);
	reg[7]=value;
	affectflag(7,value&0x80);
	affectflag(6,value==0);
	affectflag(4,false);
	affectflag(2,iff2);
	affectflag(1,false);
}

// arpiphmetic

void neg() {
	unsigned char bef=reg[7];
	reg[7]=-bef;
	affectflag(7,reg[7]&0x80);
	affectflag(6,reg[7]==0);
	affectflag(5,reg[7]&0x20);
	affectflag(4,false);
	affectflag(3,reg[7]&0x08);
	affectflag(2,bef==0x80);
	affectflag(1,true);
	affectflag(0,bef==0);
}

void decreg(unsigned char idx) {
	unsigned char bef,aft;
	if (idx==6) {
		tadr=getindex();
		bef=readmem(tadr,4);
		writemem(tadr,(bef-1)&0xff);
	} else {
		bef=reg[idx];
		reg[idx]--;
	}
	aft=bef-1;
	affectflag(7,aft&0x80);
	affectflag(6,aft==0);
	affectflag(5,aft&0x20);	// 5
	affectflag(4,(bef&0x0f)==0);
	affectflag(3,aft&0x08);	// 3
	affectflag(2,bef==0x80);
	affectflag(1,true);
}

void increg(unsigned char idx) {
	unsigned char bef,aft;
	if (idx==6) {
		tadr=getindex();
		bef=readmem(tadr,4);
		writemem(tadr,(bef+1)&0xff);
	} else {
		bef=reg[idx];
		reg[idx]++;
	}
	aft=bef+1;
	affectflag(7,aft&0x80);
	affectflag(6,aft==0);
	affectflag(5,aft&0x20);	// 5
	affectflag(4,(aft&0x0f)==0);
	affectflag(3,aft&0x08);	// 3
	affectflag(2,aft==0x80);
	affectflag(1,false);
}

void adda(unsigned char idx, bool carry=false, bool isnumber=false) {
	int bef=reg[7];
	int opt;
	if (isnumber) {opt=idx;} else {if (idx!=6) {opt=reg[corridx(idx)];} else {opt=readmem(getindex());}}
	opt=opt+(carry?1:0);
	int aft=bef+opt;
	reg[7]=aft&0xff;
	affectflag(7,reg[7]&0x80);
	affectflag(6,reg[7]==0);
	affectflag(5,reg[7]&0x20);
	affectflag(4,(bef&0x0f)+(opt&0x0f)>0x0f);
	affectflag(3,reg[7]&0x08);
	affectflag(2,(aft>0x7f) && (bef<0x7f));
	affectflag(1,false);
	affectflag(0,aft>0xff);
}

void suba(unsigned char idx, bool carry=false, bool isnumber=false) {
	int bef=reg[7];
	int opt;
	if (isnumber) {opt=idx;} else {if (idx!=6) {opt=reg[corridx(idx)];} else {opt=readmem(getindex());}}
	opt=opt+(carry?1:0);
	int aft=bef-opt;
	reg[7]=aft&0xff;
	affectflag(7,reg[7]&0x80);
	affectflag(6,reg[7]==0);
	affectflag(5,reg[7]&0x20);
	affectflag(4,(bef&0x0f)<(opt&0x0f));
	affectflag(3,reg[7]&0x08);
	affectflag(2,(aft<0x80) && (bef>0x7f));
	affectflag(1,true);
	affectflag(0,bef<opt);
}

void addhl(unsigned char idx, bool carry=false,bool ifadc=false) {
	int bef=getpair(corridx(4));
	int opt=getpair(corridx(idx))+(carry?1:0);
	int aft=bef+opt;
	ticks(4);
	setpair(corridx(4),aft&0xffff);
	ticks(3);
	if (ifadc) {
		affectflag(7,aft&0x8000);
		affectflag(6,aft==0);
		affectflag(2,(bef<0x8000)&&(aft>0x7fff));
	}
	affectflag(5,aft&0x2000);
	affectflag(4,((bef&0xfff)+(opt&0xfff))>0xfff);
	affectflag(3,aft&0x0800);
	affectflag(1,false);
	affectflag(0,aft>0xffff);
}

void sbchl(unsigned char idx) {
	int bef = getpair(4);
	int opt = getpair(idx)+(testflag(0)?1:0);
	int aft = bef - opt;
	ticks(4);
	setpair(4,aft&0xffff);
	ticks(3);
	affectflag(7,aft&0x8000);
	affectflag(6,aft==0);
	affectflag(5,aft&0x2000);
	affectflag(4,(bef&0xfff)<(opt&0xfff));
	affectflag(2,(bef>0x7fff)&&(aft<0x8000));
	affectflag(3,aft&0x0800);
	affectflag(1,true);
	affectflag(0,bef<opt);
}

// logic

void anda(unsigned char idx, bool isnumber=false) {
	unsigned char opt;
	if (isnumber) {opt=idx;} else {if (idx!=6) {opt=reg[corridx(idx)];} else {opt=readmem(getindex());}}
	reg[7]=reg[7] & opt;
	affectflag(7,reg[7]>127);
	affectflag(6,reg[7]==0);
	affectflag(5,reg[7]&0x20);
	affectflag(4,true);
	affectflag(3,reg[7]&0x08);
	affectflag(2,parity(reg[7]));
	affectflag(1,false);
	affectflag(0,false);
}

void ora(unsigned char idx, bool isnumber=false) {
	unsigned char opt;
	if (isnumber) {opt=idx;} else {if (idx!=6) {opt=reg[corridx(idx)];} else {opt=readmem(getindex());}}
	reg[7]=reg[7] | opt;
	affectflag(7,reg[7]&0x80);
	affectflag(6,reg[7]==0);
	affectflag(5,reg[7]&0x20);
	affectflag(4,false);
	affectflag(3,reg[7]&0x08);
	affectflag(2,parity(reg[7]));
	affectflag(1,false);
	affectflag(0,false);
}

void xora(unsigned char idx, bool isnumber=false) {
	unsigned char opt;
	if (isnumber) {opt=idx;} else {if (idx!=6) {opt=reg[corridx(idx)];} else {opt=readmem(getindex());}}
	reg[7]=reg[7] ^ opt;
	affectflag(7,reg[7]&0x80);
	affectflag(6,reg[7]==0);
	affectflag(5,reg[7]&0x20);
	affectflag(4,false);
	affectflag(3,reg[7]&0x08);
	affectflag(2,parity(reg[7]));
	affectflag(1,false);
	affectflag(0,false);
}

void compare(unsigned char idx, bool isnumber=false) {
	unsigned char opt;
	if (isnumber) {opt=idx;} else {if (idx!=6) {opt=reg[corridx(idx)];} else {opt=readmem(getindex());}}
	affectflag(7,(reg[7]-opt)&0x80);
	affectflag(6,reg[7]==opt);
	affectflag(5,(reg[7]-opt)&0x20);
	affectflag(4,(reg[7]&0x0f)<(opt&0x0f));
	affectflag(3,(reg[7]-opt)&0x08);
	affectflag(2,(reg[7]>0x7f) && ((reg[7]-opt)<0x80));
	affectflag(1,true);
	affectflag(0,reg[7]<opt);
}

// ldir/dr/...

void ldid(bool direct) {
	writemem(getpair(2),readmem(getpair(4)),5);
	if (direct) {incpair(2);incpair(4);} else {decpair(2);decpair(4);}
	decpair(0);
	affectflag(4,false);
	affectflag(2,getpair(0)!=0);
	affectflag(1,false);
}

void cpid(bool direct) {
	unsigned char opt=readmem(getpair(4));
	ticks(5);
	if (direct) {incpair(4);} else {decpair(4);}
	decpair(0);
	affectflag(6,reg[7]==opt);
	affectflag(2,getpair(0)!=0);
	affectflag(1,true);
}

void inid(bool direct) {
	ticks(1);
	writemem(getpair(4),in(getpair(0),3),4);
	if (direct) {incpair(4);} else {decpair(4);}
	reg[0]--;
	affectflag(6,reg[0]==0);
}

void outid(bool direct) {
	ticks(1);
	out(getpair(0),readmem(getpair(4)));
	if (direct) {incpair(4);} else {decpair(4);}
	reg[0]--;
	affectflag(6,reg[0]==0);
}

void ldidr(bool direct) {ldid(direct);if (testflag(2)) pc=adddelta(pc,-2);}
void cpidr(bool direct) {cpid(direct);if (testflag(2) and !testflag(6)) pc=adddelta(pc,-2);}
void inidr(bool direct) {inid(direct);if (reg[0]!=0) pc=adddelta(pc,-2);}
void otidr(bool direct) {outid(direct);if (reg[0]!=0) pc=adddelta(pc,-2);}

// push-pop

void push(int value,unsigned char tck1=3, unsigned char tck2=3) {
	decpair(8);
	writemem(getpair(8),(value&0xff00)/256,tck1);
	decpair(8);
	writemem(getpair(8),(value&0xff),tck2);
}

int pop(unsigned char tck1=3, unsigned char tck2=3) {
	int res;
	res=readmem(getpair(8),tck1);
	incpair(8);
	res += 256*readmem(getpair(8),tck2);
	incpair(8);
	return res;
}

void exsphl() {
	unsigned char idx=corridx(4);
	unsigned char temp;
	temp=readmem(getpair(8)); writemem(getpair(8),reg[idx+1],4); reg[idx+1]=temp;
	temp=readmem(getpair(8)+1); writemem(getpair(8)+1,reg[idx],5); reg[idx]=temp;
}

// shifts

void rld() {
	unsigned char opt=readmem(getpair(4));	// (hl)
	tmp=reg[7]&0x0f;
	reg[7]=(reg[7]&0xf0)+((opt&0xf0)>>4);
	opt=((opt&0x0f)<<4)+tmp;
	ticks(4);
	writemem(getpair(4),opt);
	affectflag(7,reg[7]&0x80);
	affectflag(6,reg[7]==0);
	affectflag(5,reg[7]&0x20);
	affectflag(4,false);
	affectflag(3,reg[7]&0x08);
	affectflag(2,parity(reg[7]));
	affectflag(1,false);
}

void rrd() {
	unsigned char opt=readmem(getpair(4));
	tmp=opt&0x0f;
	opt=((opt&0xf0)>>4)+((reg[7]&0x0f)<<4);
	reg[7]=(reg[7]&0xf0)+tmp;
	ticks(4);
	writemem(getpair(4),opt);
	affectflag(7,reg[7]&0x80);
	affectflag(6,reg[7]==0);
	affectflag(5,reg[7]&0x20);
	affectflag(4,false);
	affectflag(3,reg[7]&0x08);
	affectflag(2,parity(reg[7]));
	affectflag(1,false);
}

void rlc(unsigned char idx, bool fast=false) {
	unsigned char opt;
	bool boolbit;
	bool forindex=((idx==6) or (cbpref and (ixpref or iypref)));
	if (forindex) {tadr=getindex(delta); opt=readmem(tadr,4);} else {opt=reg[idx];}
	boolbit=(opt&0x80);
	opt=(opt&0x7f)*2+(boolbit?1:0);
	if (!fast) {affectflag(7,opt&0x80);affectflag(6,opt==0);affectflag(2,parity(opt));}
	affectflag(4,false);
	affectflag(1,false);
	affectflag(0,boolbit);
	affectflag(5,opt&0x20);	// 5
	affectflag(3,opt&0x08);	// 3
	if (forindex) {
		writemem(tadr,opt);
		if (idx!=6) reg[idx]=opt;
	} else {reg[idx]=opt;}
}

void rrc(unsigned char idx, bool fast=false) {
	unsigned char opt;
	bool boolbit;
	bool forindex=((idx==6) or (cbpref and (ixpref or iypref)));
	if (forindex) {tadr=getindex(delta); opt=readmem(tadr,4);} else {opt=reg[idx];}
	boolbit=opt&0x01;
	opt=(opt&0xfe)/2+(boolbit?128:0);
	if (!fast) {affectflag(7,opt&0x80);affectflag(6,opt==0);affectflag(2,parity(opt));}
	affectflag(4,false);
	affectflag(1,false);
	affectflag(0,boolbit);
	affectflag(5,opt&0x20);	// 5
	affectflag(3,opt&0x08);	// 3
	if (forindex) {
		writemem(tadr,opt);
		if (idx!=6) reg[idx]=opt;
	} else {reg[idx]=opt;}
}

void rl(unsigned char idx, bool fast=false) {
	unsigned char opt;
	bool boolbit;
	bool forindex=((idx==6) or (cbpref and (ixpref or iypref)));
	if (forindex) {tadr=getindex(delta); opt=readmem(tadr,4);} else {opt=reg[idx];}
	boolbit=testflag(0);
	affectflag(0,opt&0x80);
	opt=(opt&0x7f)*2+(boolbit?1:0);
	if (!fast) {affectflag(7,opt&0x80);affectflag(6,opt==0);affectflag(2,parity(opt));}
	affectflag(4,false);
	affectflag(1,false);
	affectflag(5,opt&0x20);		// 5
	affectflag(3,opt&0x08);		// 3
	if (forindex) {
		writemem(tadr,opt);
		if (idx!=6) reg[idx]=opt;
	} else {reg[idx]=opt;}
}

void rr(unsigned char idx, bool fast=false) {
	unsigned char opt;
	bool boolbit;
	bool forindex=((idx==6) or (cbpref and (ixpref or iypref)));
	if (forindex) {tadr=getindex(delta); opt=readmem(tadr,4);} else {opt=reg[idx];}
	boolbit=testflag(0);
	affectflag(0,opt&0x01);
	opt=(opt&0xfe)/2+(boolbit?128:0);
	if (!fast) {affectflag(7,opt&0x80);affectflag(6,opt==0);affectflag(2,parity(opt));}
	affectflag(4,false);
	affectflag(1,false);
	affectflag(5,opt&0x20);	// 5
	affectflag(3,opt&0x08);	// 3
	if (forindex) {writemem(tadr,opt);
		if (idx!=6) reg[idx]=opt;
	} else {reg[idx]=opt;}
}

void sla(unsigned char idx) {
	unsigned char opt;
	bool boolbit;
	bool forindex=((idx==6) or (cbpref and (ixpref or iypref)));
	if (forindex) {tadr=getindex(delta); opt=readmem(tadr,4);} else {opt=reg[idx];}
	boolbit=(opt&0x80);
	opt=(opt&0x7f)*2;
	affectflag(7,opt&0x80);
	affectflag(6,opt==0);
	affectflag(5,opt&0x20);
	affectflag(4,false);
	affectflag(3,opt&0x08);
	affectflag(2,parity(opt));
	affectflag(1,false);
	affectflag(0,boolbit);
	if (forindex) {
		writemem(tadr,opt);
		if (idx!=6) reg[idx]=opt;
	} else {reg[idx]=opt;}
}

void sra(unsigned char idx) {
	unsigned char opt;
	bool boolbit;
	bool forindex=((idx==6) or (cbpref and (ixpref or iypref)));
	if (forindex) {tadr=getindex(delta); opt=readmem(tadr,4);} else {opt=reg[idx];}
	boolbit=(opt&0x01);
	opt=(opt&0x80)+(opt&0xfe)/2;
	affectflag(7,opt&0x80);
	affectflag(6,opt==0);
	affectflag(5,opt&0x20);
	affectflag(4,false);
	affectflag(3,opt&0x08);
	affectflag(2,parity(opt));
	affectflag(1,false);
	affectflag(0,boolbit);
	if (forindex) {
		writemem(tadr,opt);
		if (idx!=6) reg[idx]=opt;
	} else {reg[idx]=opt;}
}

void sli(unsigned char idx) {
	unsigned char opt;
	bool boolbit;
	bool forindex=((idx==6) or (cbpref and (ixpref or iypref)));
	if (forindex) {tadr=getindex(delta); opt=readmem(tadr,4);} else {opt=reg[idx];}
	boolbit=(opt&0x80);
	opt=(opt&0x7f)*2+1;
	affectflag(7,opt&0x80);
	affectflag(6,opt==0);
	affectflag(5,opt&0x20);
	affectflag(4,false);
	affectflag(3,opt&0x08);
	affectflag(2,parity(opt));
	affectflag(1,false);
	affectflag(0,boolbit);
	if (forindex) {
		writemem(tadr,opt);
		if (idx!=6) reg[idx]=opt;
	} else {reg[idx]=opt;}
}

void srl(unsigned int idx) {
	unsigned char opt;
	bool boolbit;
	bool forindex=((idx==6) or (cbpref and (ixpref or iypref)));
	if (forindex) {tadr=getindex(delta); opt=readmem(tadr,4);} else {opt=reg[idx];}
	boolbit=(opt&0x01);
	opt=(opt&0xfe)/2;
	affectflag(7,false);
	affectflag(6,opt==0);
	affectflag(5,opt&0x20);
	affectflag(4,false);
	affectflag(3,opt&0x08);
	affectflag(2,parity(opt));
	affectflag(1,false);
	affectflag(0,boolbit);
	if (forindex) {
		writemem(tadr,opt);
		if (idx!=6) reg[idx]=opt;
	} else {reg[idx]=opt;}
}

// bits

void setbit(unsigned char num, unsigned char idx) {
	bool forindex=((idx==6) or (cbpref and (ixpref or iypref)));
	unsigned char opt;
	if (forindex) {
		tadr=getindex(delta); opt=readmem(tadr,4)|tmasks[num]; writemem(tadr,opt);
		if (idx!=6) reg[idx]=opt;
	} else {reg[idx]=reg[idx]|tmasks[num];}
}

void resbit(unsigned char num, unsigned char idx) {
	bool forindex=((idx==6) or (cbpref and (ixpref or iypref)));
	unsigned char opt;
	if (forindex) {
		tadr=getindex(delta); opt=readmem(tadr,4)&imasks[num]; writemem(tadr,opt);
		if (idx!=6) reg[idx]=opt;
	} else {reg[idx]=reg[idx]&imasks[num];}
}

void tstbit(unsigned char num, unsigned char idx) {
	unsigned char opt;
	bool forindex=((idx==6) or (cbpref and (ixpref or iypref)));
	if (forindex) {opt=readmem(getindex(delta));} else {opt=reg[idx];}
	affectflag(7,opt&0x80);
	affectflag(6,(opt&tmasks[num])==0);
}

// main cycle

void executecode() {
	uchar cod;
	bool prefix;
	error=false;
//	int oldpc=pc;
	edpref=false; cbpref=false;
	ixpref=false; iypref=false;
	if (nextei) {iff1=iff2=true; nextei=false;}
	do {
		prefix=false;
		cod=getbyte(4);
		if (!edpref && !cbpref) {
			if (cod==0xed) {ixpref=false;iypref=false; edpref=true; prefix=true;rreg = ((rreg+1)&0x7f)|(rreg&0x80);}
			if (cod==0xcb) {cbpref=true; prefix=true;if (!ixpref && !iypref) rreg = ((rreg+1)&0x7f)|(rreg&0x80);}
			if (cod==0xdd) {ixpref=true; iypref=false; prefix=true;rreg = ((rreg+1)&0x7f)|(rreg&0x80);}
			if (cod==0xfd) {ixpref=false; iypref=true; prefix=true;rreg = ((rreg+1)&0x7f)|(rreg&0x80);}
		}
	} while (prefix and !(cbpref and (ixpref | iypref)));
	if (cbpref and (ixpref | iypref)) {delta=getbyte(); cod=getbyte(0);}

	uchar cod_c0=cod&0xc0;
	uchar cod_f8=cod&0xf8;
	uchar cod_c7=cod&0xc7;
	uchar cod_cf=cod&0xcf;
	uchar cod_e7=cod&0xe7;

	uchar rp=(cod&0x30)/8;	// 0,2,4,6: bc,de,hl,af(sp)
	uchar reg1=(cod&0x38)/8;
	uchar reg2=cod&0x07;
	uchar usl1=(cod&0x18)/8;

	rreg = ((rreg+1)&0x7f)|(rreg&0x80);
	if (!cbpref && !edpref) {
		switch(cod) {
			case 0x00: break;				// nop
			case 0x02: writemem(getpair(0),reg[7]); break;	// ld (bc),a
			case 0x07: rlc(7,true); break;			// rlca
			case 0x08: exchange(6);exchange(7);break;	// ex af,af'
			case 0x0a: reg[7]=readmem(getpair(0)); break;	// ld a,(bc)
			case 0x0f: rrc(7,true); break;			// rrca
			case 0x10: ticks(1); tmp=getbyte(); reg[0]--; if (reg[0]!=0) {pc=adddelta(pc,tmp);} break;	// djnz e
			case 0x12: writemem(getpair(2),reg[7]); break;	// ld (de),a
			case 0x17: rl(7,true); break;			// rla
			case 0x18: tmp=getbyte(); pc=adddelta(pc,tmp); break;	// jr e
			case 0x1a: reg[7]=readmem(getpair(2)); break;	// ld a,(de)
			case 0x1f: rr(7,true); break;			// rra
			case 0x22: ldmnnrp(corridx(4)); break;		// ld (nn),hl
			case 0x27: daa(); break;			// DAAAAAAAAAAAAAAAAAAAAAAAAA!!!!!!!!адин!адин11
			case 0x2a: ldrpmnn(corridx(4)); break;		// ld hl,(nn)
			case 0x2f: reg[7]=255-reg[7];
					affectflag(5,reg[7]&0x20);
					affectflag(3,reg[7]&0x08);
					affectflag(4,true);
					affectflag(1,true);
					break;	// cpl
			case 0x32: writemem(getword(),reg[7]); break;	// ld (nn),a
			case 0x37: affectflag(1,false); affectflag(0,true); break;		// scf
			case 0x3a: reg[7]=readmem(getword()); break;	// ld a,(nn)
			case 0x3f: affectflag(0,!testflag(0)); break;	// ccf
			case 0x76: if (!intupt) {pc=(pc-1)&0xffff;} break;	// halt
			case 0xc3: pc=getword(); break;			// jp nn
			case 0xc6: adda(getbyte(),false,true); break;	// add a,n
			case 0xc9: pc=pop(); break;			// ret
			case 0xce: adda(getbyte(),testflag(0),true); break;	// adc a,n
			case 0xcd: tadr=getword(3,4); push(pc); pc=tadr; break;	// call nn
			case 0xd3: out(256*reg[7]+getbyte(),reg[7]); break;	// out (n),a
			case 0xd6: suba(getbyte(),false,true); break;	// sub n
			case 0xd9: for(tmp2=0;tmp2<6;tmp2++){exchange(tmp2);} break;	// exx
			case 0xdb: reg[7]=in(getbyte()+256*reg[7]); break;	// in a,(n)
			case 0xde: suba(getbyte(),testflag(0),true); break;	// sbc a,n
			case 0xe3: exsphl(); break;			// ex (sp),hl
			case 0xe6: anda(getbyte(),true); break;		// and n
			case 0xe9: pc=getpair(corridx(4)); break;	// jp (hl)
			case 0xeb: tadr=getpair(2); setpair(2,getpair(4)); setpair(4,tadr); break;	// ex de,hl
			case 0xee: xora(getbyte(),true); break;		// xor n
			case 0xf3: iff1=false; iff2=false; break;	// di
			case 0xf6: ora(getbyte(),true); break;		// or n
			case 0xf9: setpair(8,getpair(corridx(4))); ticks(2); break;	// ld sp,hl
			case 0xfb: nextei=true; break;		// ei
			case 0xfe: compare(getbyte(),true); break;	// cp n
		default: switch(cod_cf) {
			case 0x01: setpair(corridx(idxtosp(rp)),getword()); break;	// ld rp,nn
			case 0x03: incpair(corridx(idxtosp(rp))); ticks(2); break;	// inc rp
			case 0x09: addhl(corridx(idxtosp(rp))); break;			// add hl,rp
			case 0x0b: decpair(corridx(idxtosp(rp))); ticks(2); break;	// dec rp
			case 0xc1: setpair(corridx(rp),pop()); break;			// pop rp
			case 0xc5: ticks(1); push(getpair(corridx(rp))); break;		// push rp
		default: switch(cod_e7) {
			case 0x20: tmp=getbyte(); if(testusl(usl1)) {pc=adddelta(pc,tmp);} break;	// jr cc,e
		default: switch(cod_c7) {
			case 0x04: increg(corridx(reg1)); break;	// inc reg
			case 0x05: decreg(corridx(reg1)); break;	// dec reg
			case 0x06: ldreg(reg1,0,true); break;	// ld reg,n
			case 0xc0: ticks(1); if (testusl(reg1)) {pc=pop();} break;	// ret cc
			case 0xc2: tadr=getword(); if(testusl(reg1)) {pc=tadr;} break;	// jp cc,nn
			case 0xc7: push(pc); pc=reg1*8; break;		// rst n
			case 0xc4: tadr=getword(3,4); if(testusl(reg1)) {push(pc); pc=tadr;} break;	// call cc,nn
		default: switch(cod_f8) {
			case 0x80: adda(reg2); break;			// add a,reg
			case 0x88: adda(reg2,testflag(0)); break;	// adc a,reg
			case 0x90: suba(reg2); break;			// sub reg
			case 0x98: suba(reg2,testflag(0)); break;	// sbc a,reg
			case 0xa0: anda(reg2); break;			// and reg
			case 0xa8: xora(reg2); break;			// xor reg
			case 0xb0: ora(reg2); break;			// or reg
			case 0xb8: compare(reg2); break;		// cp reg
		default: switch(cod_c0) {
			case 0x40: ldreg(reg1,reg2); break;		// ld reg,reg
		}}}}}}
	}

	if (cbpref) {
		switch(cod_f8) {
			case 0x00: rlc(reg2); break;
			case 0x08: rrc(reg2); break;
			case 0x10: rl(reg2); break;
			case 0x18: rr(reg2); break;
			case 0x20: sla(reg2); break;
			case 0x28: sra(reg2); break;
			case 0x30: sli(reg2); break;
			case 0x38: srl(reg2); break;
		default: switch(cod_c0) {
			case 0x40: tstbit(reg1,reg2); break;		// bit n,reg
			case 0x80: resbit(reg1,reg2); break;		// res n,reg
			case 0xc0: setbit(reg1,reg2); break;		// set n,reg
		}}
	}

	if (edpref) {
		switch(cod) {
			case 0x44: neg(); break;
			case 0x45: iff1=iff2; pc=pop(); break;		// retn
			case 0x46: imode=0; break;			// im 0
			case 0x47: ireg=reg[7]; ticks(1); break;	// ld i,a
			case 0x4c: neg(); break;			// * neg
			case 0x4d: iff1=iff2; pc=pop(); break;		// reti
			case 0x4e: imode=0; break;			// * im 0
			case 0x4f: rreg=reg[7]; ticks(1); break;	// ld r,a
			case 0x54: neg(); break;			// * neg
			case 0x55: iff1=iff2; pc=pop(); break;		// * retn
			case 0x56: imode=1; break;			// im 1
			case 0x57: ldair(ireg); break;			// ld a,i
			case 0x5c: neg(); break;			// * neg
			case 0x5d: iff1=iff2; pc=pop(); break;		// * reti
			case 0x5e: imode=2; break;			// im 2
			case 0x5f: ldair(rreg); break;			// ld a,r
			case 0x64: neg(); break;			// * neg
			case 0x65: iff1=iff2; pc=pop(); break;		// * retn
			case 0x66: imode=0; break;			// * im 0
			case 0x67: rrd(); break;
			case 0x6c: neg(); break;			// * neg
			case 0x6d: iff1=iff2; pc=pop(); break;		// * retn
			case 0x6e: imode=0; break;			// * im 0
			case 0x6f: rld(); break;
			case 0x71: break;				// *nop (out (c),f)
			case 0x74: neg(); break;			// * neg
			case 0x75: iff1=iff2; pc=pop(); break;		// * retn
			case 0x76: imode=1; break;			// * im 1
			case 0x7c: neg(); break;			// * neg
			case 0x7d: iff1=iff2; pc=pop(); break;		// * retn
			case 0x7e: imode=2; break;			// * im 2
			case 0xa0: ldid(true); break;
			case 0xa1: cpid(true); break;
			case 0xa2: inid(true); break;
			case 0xa3: outid(true); break;
			case 0xa8: ldid(false); break;
			case 0xa9: cpid(false); break;
			case 0xaa: inid(false); break;
			case 0xab: outid(false); break;
			case 0xb0: ldidr(true); break;
			case 0xb1: cpidr(true); break;
			case 0xb2: inidr(true); break;
			case 0xb3: otidr(true); break;
			case 0xb8: ldidr(false); break;
			case 0xb9: cpidr(false); break;
			case 0xba: inidr(false); break;
			case 0xbb: otidr(false); break;
		default: switch(cod_c7) {
			case 0x40: inreg(reg1); break;			// in reg,(c)
			case 0x41: outreg(reg1); break;			// out (c),reg
		default: switch(cod_cf) {
			case 0x42: sbchl(idxtosp(rp)); break;		// sbc hl,rp
			case 0x43: ldmnnrp(idxtosp(rp)); break;		// ld (nn),rp
			case 0x4a: addhl(rp,testflag(0),true); break;	// adc hl,rp
			case 0x4b: ldrpmnn(idxtosp(rp)); break;		// ld rp,(nn)
		default: break;
		}}}
	}
	if ((pc>0x3cff) && (pc<0x3e00) && bdi.enable && (mem.prt0 & 0x10)) {bdi.active=true; machine->setrom();}		// активация тырдоса
	if (pc>0x3fff) {bdi.active=false; machine->setrom();}
	
	BPoint bp;
	bp.adr = pc;
	bp.page = getbpage(pc);
	error = (dbg->findbp(bp)!=-1);
	if (error) dbg->start();
}

void execute() {
	do {
//		ticks(4);
		executecode();
	} while (!intupt && !error);
	
	if (intupt && iff1 && !(dbg->active)) {
		iff2=iff1=false;
		switch (imode) {
			case 0: ticks(6); push(pc,3,3); pc=0x38; break;		// rst 56 (get data from DATA bus)
			case 1: ticks(7); push(pc,3,3); pc=0x38; break;		// rst 56
			case 2: ticks(7); push(pc,3,3);
				tadr=(ireg<<8)|0xff; pc=mem.rd(tadr)+(mem.rd(tadr+1)<<8);
				break;		// int mode 2
		}
		BPoint bp;
		bp.adr = pc;
		bp.page = getbpage(pc);
		if (dbg->findbp(bp)!=-1) dbg->start();
	}
}
